#!/bin/sh
# SPDX-License-Identifier: BSD-3-Clause
# Copyright (c) 2025 Robin Jarry

set -eu

revision_range="${1?revision range}"

valid=0
revisions=$(git rev-list --reverse "$revision_range")
total=$(echo $revisions | wc -w)
if [ "$total" -eq 0 ]; then
	exit 0
fi
tmp=$(mktemp)
trap "rm -f $tmp" EXIT

allowed_trailers="
Fixes
Closes
Link
Cc
Suggested-by
Requested-by
Reported-by
Assisted-by
Signed-off-by
Co-authored-by
Tested-by
Reviewed-by
Acked-by
"

n=0
title=
fail=false
repo=rjarry/libecoli
repo_url=https://github.com/$repo
api_url=https://api.github.com/repos/$repo

err() {
	echo "error [commit $n/$total] '$title' $*" >&2
	fail=true
}

check_issue() {
	json=$(curl -f -X GET -L --no-progress-meter \
		-H "Accept: application/vnd.github+json" \
		-H "X-GitHub-Api-Version: 2022-11-28" \
		"$api_url/issues/${1##*/}") || return 1
	test "$(printf '%s\n' "$json" | jq -r .state)" = open
}

for rev in $revisions; do
	n=$((n + 1))
	title=$(git log --format='%s' -1 "$rev")
	fail=false

	if ! echo "$title" | grep -qE '^Revert ".+"$'; then
		if [ "$(echo "$title" | wc -m)" -gt 72 ]; then
			err "title is longer than 72 characters, please make it shorter"
		fi
		if ! echo "$title" | grep -qE '^[a-z0-9,{}/_-]+: '; then
			err "title lacks a lowercase topic prefix (e.g. 'ipv6:')"
		fi
		if echo "$title" | grep -qE '^[a-z0-9,{}/_-]+: [A-Z][a-z]'; then
			err "title starts with an capital letter, please use lower case"
		fi
		if ! echo "$title" | grep -qE '[[:alnum:])]$'; then
			err "title ends with punctuation, please remove it"
		fi
	fi

	author=$(git log --format='%an <%ae>' -1 "$rev")
	if ! git log --format="%(trailers:key=Signed-off-by,only,valueonly,unfold)" -1 "$rev" |
			grep -qFx "$author"; then
		err "'Signed-off-by: $author' trailer is missing"
	fi

	for trailer in $(git log --format="%(trailers:only,keyonly)" -1 "$rev"); do
		if ! echo "$allowed_trailers" | grep -qFx "$trailer"; then
			err "trailer '$trailer' is misspelled or not in the sanctioned list"
		fi
	done

	git log --format="%(trailers:key=Closes,only,valueonly,unfold)" -1 "$rev" > $tmp
	while read -r value; do
		if [ -z "$value" ]; then
			continue
		fi
		case "$value" in
		$repo_url/*/[0-9]*)
			if ! check_issue "$value"; then
				err "'$value' does not reference a valid open issue"
			fi
			;;
		\#[0-9]*)
			value=${value#\#}
			err "please use the full issue URL: 'Closes: $repo_url/issues/$value'"
			;;
		*)
			err "invalid trailer value '$value'. The 'Closes:' trailer must only be used to reference issue URLs"
			;;
		esac
	done < "$tmp"

	git log --format="%(trailers:key=Fixes,only,valueonly,unfold)" -1 "$rev" > $tmp
	while read -r value; do
		if [ -z "$value" ]; then
			continue
		fi
		fixes_rev=$(echo "$value" | sed -En 's/([A-Fa-f0-9]{7,})[[:space:]]\(".*"\)/\1/p')
		if ! git cat-file commit "$fixes_rev" >/dev/null; then
			err "trailer 'Fixes: $value' does not refer to a known commit"
		fi
	done < "$tmp"

	body=$(git log --format='%b' -1 "$rev")
	body=${body%$(git log --format='%(trailers)' -1 "$rev")}
	if [ "$(echo "$body" | wc -w)" -lt 3 ]; then
		err "body has less than three words, please describe your changes"
	fi

	if ! git log --format='%s%n%b' -1 "$rev" | codespell -; then
		err "spelling errors in title and/or body"
	fi

	if ! [ "$(git log --format='%P' -1 "$rev" | wc -w)" = 1 ]; then
		err "merge commit found, please rebase your code"
	fi

	if [ "$fail" = true ]; then
		continue
	fi
	echo "ok    [commit $n/$total] '$title'"
	valid=$((valid + 1))
done

echo "$valid/$total valid commits"
if [ "$valid" -ne "$total" ]; then
	exit 1
fi
